## smartdns 33+dfsg

=== src/Makefile ===

# Copyright (C) 2018-2020 Ruilin Peng (Nick) <pymumu@gmail.com>.
#
# smartdns is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# smartdns is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

BIN=smartdns 
OBJS_LIB=lib/rbtree.o lib/art.o lib/bitops.o lib/radix.o lib/conf.o
OBJS=smartdns.o fast_ping.o dns_client.o dns_server.o dns.o util.o tlog.o dns_conf.o dns_cache.o http_parse.o $(OBJS_LIB)

# cflags
ifndef CFLAGS
CFLAGS =-O2 -g -Wall -Wstrict-prototypes -fno-omit-frame-pointer -Wstrict-aliasing 
endif
override CFLAGS +=-Iinclude
override CFLAGS += -DBASE_FILE_NAME=\"$(notdir $<)\"
ifdef VER
override CFLAGS += -DSMARTDNS_VERION=\"$(VER)\"
endif

CXXFLAGS=-O2 -g -Wall -std=c++11 
override CXXFLAGS +=-Iinclude

# ldflags
ifeq ($(STATIC), yes)
override LDFLAGS += -lssl -lcrypto -Wl,--whole-archive -lpthread -Wl,--no-whole-archive -ldl -static
else
override LDFLAGS += -lssl -lcrypto -lpthread 
endif

.PHONY: all clean

all: $(BIN)
 
$(BIN) : $(OBJS)
	$(CC) $(OBJS) -o $@ $(LDFLAGS)

clean:
	$(RM) $(OBJS) $(BIN)

=== debian/changelog ===
smartdns (33+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
    ACK by maintainer.
  * Backport patch to fix TimeoutStopSec key in systemd unit file
    (Closes: #989072)

 -- Shengjing Zhu <zhsj@debian.org>  Fri, 28 May 2021 00:37:23 +0800

smartdns (33+dfsg-2) unstable; urgency=medium

  [ Chris Lamb ]
  * Make the build reproducible (Closes: #970908)

 -- Mo Zhou <lumin@debian.org>  Wed, 02 Dec 2020 19:57:30 +0800

smartdns (33+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * autopkgtest: call command with explict sbin path

 -- Aron Xu <aron@debian.org>  Mon, 28 Sep 2020 15:45:04 +0800

smartdns (33+dfsg-1) unstable; urgency=medium

  * New upstream version 33+dfsg
  * Mark autopkgtest case as superficial.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Thu, 24 Sep 2020 10:30:12 +0800

smartdns (32+dfsg-1~exp1) experimental; urgency=medium

  * New upstream version 32+dfsg

 -- Mo Zhou <lumin@debian.org>  Wed, 02 Sep 2020 07:54:08 +0800

smartdns (31+dfsg-1~exp2) experimental; urgency=medium

  * Update the build target to fix the missing systemd service.

 -- Mo Zhou <lumin@debian.org>  Wed, 27 May 2020 02:37:06 +0000

smartdns (31+dfsg-1~exp1) experimental; urgency=medium

  * New upstream version 31+dfsg
  * Refresh URL in debian/u1.txt
  * Apply wrap-and-sort.
  * Bump debhelper compat level to 13 (no change).
  * Add a usage hint in debian/qr-regen.sh
  * Add dversionmangle in d/watch.
  * Fix file paths in d/copyright.
  * Add autopkgtest control file.

 -- Mo Zhou <lumin@debian.org>  Tue, 26 May 2020 15:10:09 +0800

smartdns (30+dfsg-1~exp1) experimental; urgency=medium

  * Initial release. (Closes: #951307)

 -- Mo Zhou <lumin@debian.org>  Wed, 01 Apr 2020 20:12:03 +0800

=== debian/control ===
Source: smartdns
Section: net
Homepage: https://github.com/pymumu/smartdns
Priority: optional
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/debian/smartdns.git
Vcs-Browser: https://salsa.debian.org/debian/smartdns
Maintainer: Mo Zhou <lumin@debian.org>
Build-Depends: debhelper-compat (= 13), libssl-dev, qrencode, zbar-tools
Rules-Requires-Root: no

Package: smartdns
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: local DNS server to obtain the fastest IP for the best experience
 SmartDNS is a local DNS server. SmartDNS accepts DNS query requests from local
 clients, obtains DNS query results from multiple upstream DNS servers, and
 returns the fastest access results to clients.  Avoiding DNS pollution and
 improving network access speed, supports high-performance ad filtering.  Unlike
 dnsmasq's all-servers, smartdns returns the fastest access resolution.

=== debian/rules ===
#!/usr/bin/make -f  

include /usr/share/dpkg/default.mk

export VER=$(DEB_VERSION)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ -Smakefile

override_dh_auto_test:
	:

override_dh_auto_install:
	$(SHELL) debian/qr-regen.sh
	cp -v alipay_donate.jpg doc/
	cp -v wechat_donate.jpg doc/
	:

## smartdns 35+dfsg

=== src/Makefile ===
--- 
+++ 
@@ -20,7 +20,7 @@
 
 # cflags
 ifndef CFLAGS
-CFLAGS =-O2 -g -Wall -Wstrict-prototypes -fno-omit-frame-pointer -Wstrict-aliasing 
+CFLAGS =-O2 -g -Wall -Wstrict-prototypes -fno-omit-frame-pointer -Wstrict-aliasing -funwind-tables
 endif
 override CFLAGS +=-Iinclude
 override CFLAGS += -DBASE_FILE_NAME=\"$(notdir $<)\"
@@ -35,7 +35,7 @@
 ifeq ($(STATIC), yes)
 override LDFLAGS += -lssl -lcrypto -Wl,--whole-archive -lpthread -Wl,--no-whole-archive -ldl -static
 else
-override LDFLAGS += -lssl -lcrypto -lpthread 
+override LDFLAGS += -lssl -lcrypto -lpthread -ldl
 endif
 
 .PHONY: all clean

=== package/luci-compat/tool/po2lmo/Makefile ===

INSTALL = install
PREFIX  = /usr/bin

po2lmo: src/po2lmo.o src/template_lmo.o
	$(CC) $(LDFLAGS) -o src/po2lmo src/po2lmo.o src/template_lmo.o

install:
	$(INSTALL) -m 755 src/po2lmo $(PREFIX)

clean:
	$(RM) src/po2lmo src/*.o

=== debian/changelog ===
smartdns (35+dfsg-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Update standards version to 4.5.1, no changes needed.

  [ Mo Zhou ]
  * New upstream version 35+dfsg
  * Rebase existing patches and remove merged systemd unit patch.

 -- Mo Zhou <lumin@debian.org>  Thu, 06 Jan 2022 10:12:34 -0500

## smartdns 36.1%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: net
 Homepage: https://github.com/pymumu/smartdns
 Priority: optional
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Git: https://salsa.debian.org/debian/smartdns.git
 Vcs-Browser: https://salsa.debian.org/debian/smartdns
 Maintainer: Mo Zhou <lumin@debian.org>

## smartdns 36.1+dfsg

=== Makefile ===
# Copyright (C) 2018-2020 Ruilin Peng (Nick) <pymumu@gmail.com>.
#
# smartdns is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# smartdns is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

PKG_CONFIG := pkg-config
DESTDIR :=
PREFIX := /usr
SBINDIR := $(PREFIX)/sbin
SYSCONFDIR := /etc
RUNSTATEDIR := /var/run
SYSTEMDSYSTEMUNITDIR := $(shell ${PKG_CONFIG} --variable=systemdsystemunitdir systemd)
SMARTDNS_SYSTEMD = systemd/smartdns.service

.PHONY: all clean install SMARTDNS_BIN
all: SMARTDNS_BIN 

SMARTDNS_BIN: $(SMARTDNS_SYSTEMD)
	$(MAKE) $(MFLAGS) -C src all 

$(SMARTDNS_SYSTEMD): systemd/smartdns.service.in
	cp $< $@
	sed -i 's|@SBINDIR@|$(SBINDIR)|' $@
	sed -i 's|@SYSCONFDIR@|$(SYSCONFDIR)|' $@
	sed -i 's|@RUNSTATEDIR@|$(RUNSTATEDIR)|' $@

clean:
	$(MAKE) $(MFLAGS) -C src clean  
	$(RM) $(SMARTDNS_SYSTEMD)

install: SMARTDNS_BIN 
	install -v -m 0640 -D -t $(DESTDIR)$(SYSCONFDIR)/default etc/default/smartdns
	install -v -m 0755 -D -t $(DESTDIR)$(SYSCONFDIR)/init.d etc/init.d/smartdns
	install -v -m 0640 -D -t $(DESTDIR)$(SYSCONFDIR)/smartdns etc/smartdns/smartdns.conf
	install -v -m 0755 -D -t $(DESTDIR)$(SBINDIR) src/smartdns
	install -v -m 0644 -D -t $(DESTDIR)$(SYSTEMDSYSTEMUNITDIR) systemd/smartdns.service

=== debian/changelog ===
smartdns (36.1+dfsg-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Mo Zhou <lumin@debian.org>  Mon, 09 May 2022 16:07:25 -0400

smartdns (36.1+dfsg-1) unstable; urgency=medium

  * New upstream version 36.1+dfsg

 -- Mo Zhou <lumin@debian.org>  Fri, 08 Apr 2022 14:57:02 -0400

smartdns (36+dfsg-1) unstable; urgency=medium

  * New upstream version 36+dfsg

 -- Mo Zhou <lumin@debian.org>  Sun, 03 Apr 2022 19:58:47 -0400

## smartdns 38.1+dfsg

=== debian/changelog ===
smartdns (38.1+dfsg-1) unstable; urgency=medium

  * New upstream version 38.1+dfsg
  * Refresh existing patches.
  * Add lintian overrides.

 -- Mo Zhou <lumin@debian.org>  Fri, 28 Oct 2022 13:43:00 -0400

## smartdns 39+dfsg

=== debian/changelog ===
smartdns (39+dfsg-1) unstable; urgency=medium

  * New upstream version 39+dfsg
  * Rebase existing patches.

 -- Mo Zhou <lumin@debian.org>  Sun, 18 Dec 2022 11:21:51 -0500

## smartdns 40+dfsg

=== debian/changelog ===
smartdns (40+dfsg-1) unstable; urgency=medium

  * New upstream version 40+dfsg
  * Rebase existing patches.

 -- Mo Zhou <lumin@debian.org>  Fri, 17 Feb 2023 16:38:29 -0500

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,4 @@
-#!/usr/bin/make -f  
+#!/usr/bin/make -f
 
 include /usr/share/dpkg/default.mk

## smartdns 42+dfsg

=== debian/changelog ===
smartdns (42+dfsg-1) unstable; urgency=medium

  * New upstream version 42+dfsg
  * Rebase existing patches.

 -- Mo Zhou <lumin@debian.org>  Thu, 13 Jul 2023 21:39:03 -0700

## smartdns 43+dfsg

=== src/Makefile ===

# Copyright (C) 2018-2023 Ruilin Peng (Nick) <pymumu@gmail.com>.
#
# smartdns is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# smartdns is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

BIN=smartdns 
OBJS_LIB=lib/rbtree.o lib/art.o lib/bitops.o lib/radix.o
OBJS_MAIN=smartdns.o fast_ping.o dns_client.o dns_server.o dns.o util.o tlog.o dns_conf.o dns_cache.o http_parse.o proxy.o lib/conf.o lib/nftset.o
OBJS=$(OBJS_MAIN) $(OBJS_LIB)

# cflags
ifndef CFLAGS
 ifdef DEBUG
  CFLAGS = -g -DDEBUG
 else
  CFLAGS = -O2
 endif
CFLAGS +=-Wall -Wstrict-prototypes -fno-omit-frame-pointer -Wstrict-aliasing -funwind-tables -Wmissing-prototypes -Wshadow -Wextra -Wno-unused-parameter -Wno-implicit-fallthrough
endif
override CFLAGS +=-Iinclude
override CFLAGS += -DBASE_FILE_NAME='"$(notdir $<)"'
override CFLAGS += $(EXTRA_CFLAGS)
ifdef VER
override CFLAGS += -DSMARTDNS_VERION='"$(VER)"'
endif

CXXFLAGS=-O2 -g -Wall -std=c++11 
override CXXFLAGS +=-Iinclude

# ldflags
ifeq ($(STATIC), yes)
 override LDFLAGS += -lssl -lcrypto -Wl,--whole-archive -lpthread -Wl,--no-whole-archive -ldl -static
else
 override LDFLAGS += -lssl -lcrypto -lpthread -ldl
endif

.PHONY: all clean

all: $(BIN)

$(BIN) : $(OBJS)
	$(CC) $(OBJS) -o $@ $(LDFLAGS)

clang-tidy:
	clang-tidy -p=. $(OBJS_MAIN:.o=.c) -- $(CFLAGS)

clean:
	$(RM) $(OBJS) $(BIN)

## smartdns 45+dfsg

=== src/Makefile ===

# Copyright (C) 2018-2024 Ruilin Peng (Nick) <pymumu@gmail.com>.
#
# smartdns is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# smartdns is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

BIN=smartdns 
OBJS_LIB=$(patsubst %.c,%.o,$(wildcard lib/*.c))
OBJS_MAIN=$(patsubst %.c,%.o,$(wildcard *.c))
OBJS=$(OBJS_MAIN) $(OBJS_LIB)

# cflags
ifndef CFLAGS
 ifdef DEBUG
  CFLAGS = -g -DDEBUG
 else
  CFLAGS = -O2
 endif
 CFLAGS +=-Wall -Wstrict-prototypes -fno-omit-frame-pointer -Wstrict-aliasing -funwind-tables -Wmissing-prototypes -Wshadow -Wextra -Wno-unused-parameter -Wno-implicit-fallthrough
endif

override CFLAGS +=-Iinclude
override CFLAGS += -DBASE_FILE_NAME='"$(notdir $<)"'
override CFLAGS += $(EXTRA_CFLAGS)

ifdef VER
 override CFLAGS += -DSMARTDNS_VERION='"$(VER)"'
endif

HAS_GIT := $(shell command -v git 2> /dev/null)
ifndef NO_GIT_VER
 ifdef HAS_GIT
  IS_GIT_REPO := $(shell git rev-parse --is-inside-work-tree 2>/dev/null)
  ifdef IS_GIT_REPO
   override COMMIT_VERION = $(shell git describe --tags --always --dirty)
  endif
 endif
endif

ifdef COMMIT_VERION
 override CFLAGS += -DCOMMIT_VERION='"$(shell git describe --tags --always --dirty)"'
endif

CXXFLAGS=-O2 -g -Wall -std=c++11 
override CXXFLAGS +=-Iinclude

ifeq ($(STATIC), yes)
 override CFLAGS += -DBUILD_STATIC
 override LDFLAGS += -lssl -lcrypto -Wl,--whole-archive -lpthread -Wl,--no-whole-archive -ldl -lm -static -rdynamic
else
 override LDFLAGS += -lssl -lcrypto -lpthread -ldl -lm -rdynamic
endif

.PHONY: all clean

all: $(BIN)

$(BIN) : $(OBJS)
	$(CC) $(OBJS) -o $@ $(LDFLAGS)

clang-tidy:
	clang-tidy -p=. $(OBJS_MAIN:.o=.c) -- $(CFLAGS)

clean:
	$(RM) $(OBJS) $(BIN)

=== debian/changelog ===
smartdns (45+dfsg-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:01:25 +1100

smartdns (45+dfsg-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 21:22:50 +0000

smartdns (45+dfsg-1) unstable; urgency=medium

  * New upstream version 45+dfsg
  * Rebase existing patches.
  * Update copyright information.

 -- Mo Zhou <lumin@debian.org>  Thu, 15 Feb 2024 14:13:09 -0500

smartdns (43+dfsg-1) unstable; urgency=medium

  * New upstream version 43+dfsg
  * Refresh existing patches.
  * Add clean target to solve twice in a row FTBFS. (Closes: #1047008)

 -- Mo Zhou <lumin@debian.org>  Fri, 18 Aug 2023 18:34:06 -0400

## smartdns 46+dfsg

=== debian/changelog ===
smartdns (46+dfsg-1ubuntu1) plucky; urgency=medium

  * SECURITY UPDATE: Integer Overflow
    - debian/patches/CVE-2024-42643.patch: Update checks for memory
      alignment
    - CVE-2024-42643

 -- Bruce Cable <bruce.cable@canonical.com>  Mon, 24 Mar 2025 16:13:22 +1100

smartdns (46+dfsg-1) unstable; urgency=medium

  * New upstream version 46+dfsg

 -- Mo Zhou <lumin@debian.org>  Wed, 03 Jul 2024 02:51:02 -0400

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,8 @@
 Standards-Version: 4.5.1
 Vcs-Git: https://salsa.debian.org/debian/smartdns.git
 Vcs-Browser: https://salsa.debian.org/debian/smartdns
-Maintainer: Mo Zhou <lumin@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Mo Zhou <lumin@debian.org>
 Build-Depends: debhelper-compat (= 13), libssl-dev, qrencode, zbar-tools
 Rules-Requires-Root: no

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%smartdns-$1.tar.gz%,repacksuffix=+dfsg,dversionmangle=s/\+dfsg\d*$//" \
https://github.com/pymumu/smartdns/tags \
(?:.*?/)Releasev?(\d[\d.]*)\.tar\.gz debian uupdate

## smartdns 46.1%2Bdfsg

=== package/openwrt/Makefile ===
#
# Copyright (c) 2018-2024 Nick Peng (pymumu@gmail.com)
# This is free software, licensed under the GNU General Public License v3.
#

include $(TOPDIR)/rules.mk

PKG_NAME:=smartdns
PKG_VERSION:=1.2023.41
PKG_RELEASE:=1

PKG_SOURCE_PROTO:=git
PKG_SOURCE_URL:=https://www.github.com/pymumu/smartdns.git
PKG_MIRROR_HASH:=skip
PKG_SOURCE_VERSION:=60a3719ec739be2cc1e11724ac049b09a75059cb

PKG_MAINTAINER:=Nick Peng <pymumu@gmail.com>
PKG_LICENSE:=GPL-3.0-or-later
PKG_LICENSE_FILES:=LICENSE

PKG_BUILD_PARALLEL:=1

include $(INCLUDE_DIR)/package.mk

MAKE_VARS += VER=$(PKG_VERSION) 
MAKE_PATH:=src

define Package/smartdns
  SECTION:=net
  CATEGORY:=Network
  TITLE:=smartdns server
  DEPENDS:=+libpthread +libopenssl
  URL:=https://www.github.com/pymumu/smartdns/
endef

define Package/smartdns/description
SmartDNS is a local DNS server which accepts DNS query requests from local network clients,
gets DNS query results from multiple upstream DNS servers concurrently, and returns the fastest IP to clients.
Unlike dnsmasq's all-servers, smartdns returns the fastest IP, and encrypt DNS queries with DoT or DoH. 
endef

define Package/smartdns/conffiles
/etc/config/smartdns
/etc/smartdns/address.conf
/etc/smartdns/blacklist-ip.conf
/etc/smartdns/custom.conf
/etc/smartdns/domain-block.list
/etc/smartdns/domain-forwarding.list
endef

define Package/smartdns/install
	$(INSTALL_DIR) $(1)/usr/sbin $(1)/etc/config $(1)/etc/init.d 
	$(INSTALL_DIR) $(1)/etc/smartdns $(1)/etc/smartdns/domain-set $(1)/etc/smartdns/conf.d/
	$(INSTALL_DIR) $(1)/etc/smartdns/ip-set $(1)/etc/smartdns/download
	$(INSTALL_BIN) $(PKG_BUILD_DIR)/src/smartdns $(1)/usr/sbin/smartdns
	$(INSTALL_BIN) $(PKG_BUILD_DIR)/package/openwrt/files/etc/init.d/smartdns $(1)/etc/init.d/smartdns
	$(INSTALL_CONF) $(PKG_BUILD_DIR)/package/openwrt/address.conf $(1)/etc/smartdns/address.conf
	$(INSTALL_CONF) $(PKG_BUILD_DIR)/package/openwrt/blacklist-ip.conf $(1)/etc/smartdns/blacklist-ip.conf
	$(INSTALL_CONF) $(PKG_BUILD_DIR)/package/openwrt/custom.conf $(1)/etc/smartdns/custom.conf
	$(INSTALL_CONF) $(PKG_BUILD_DIR)/package/openwrt/domain-block.list $(1)/etc/smartdns/domain-block.list
	$(INSTALL_CONF) $(PKG_BUILD_DIR)/package/openwrt/domain-forwarding.list $(1)/etc/smartdns/domain-forwarding.list
	$(INSTALL_CONF) $(PKG_BUILD_DIR)/package/openwrt/files/etc/config/smartdns $(1)/etc/config/smartdns
endef

$(eval $(call BuildPackage,smartdns))

=== debian/changelog ===
smartdns (46.1+dfsg-1) unstable; urgency=medium

  * New upstream version 46.1+dfsg

 -- Mo Zhou <lumin@debian.org>  Thu, 20 Mar 2025 17:49:12 -0400

## smartdns 46.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (C) 2018-2020 Ruilin Peng (Nick) <pymumu@gmail.com>.
+# Copyright (C) 2018-2024 Ruilin Peng (Nick) <pymumu@gmail.com>.
 #
 # smartdns is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,7 +18,7 @@
 PREFIX := /usr
 SBINDIR := $(PREFIX)/sbin
 SYSCONFDIR := /etc
-RUNSTATEDIR := /var/run
+RUNSTATEDIR := /run
 SYSTEMDSYSTEMUNITDIR := $(shell ${PKG_CONFIG} --variable=systemdsystemunitdir systemd)
 SMARTDNS_SYSTEMD = systemd/smartdns.service

=== src/Makefile ===
--- 
+++ 
@@ -27,6 +27,12 @@
   CFLAGS = -O2
  endif
  CFLAGS +=-Wall -Wstrict-prototypes -fno-omit-frame-pointer -Wstrict-aliasing -funwind-tables -Wmissing-prototypes -Wshadow -Wextra -Wno-unused-parameter -Wno-implicit-fallthrough
+endif
+
+HASH := \#
+HAS_UNWIND := $(shell echo '$(HASH)include <unwind.h>\nvoid main() { _Unwind_Backtrace(0, 0);}' | $(CC) -x c - -o /dev/null >/dev/null 2>&1 && echo 1 || echo 0)
+ifeq ($(HAS_UNWIND), 1)
+override CFLAGS += -DHAVE_UNWIND_BACKTRACE
 endif
 
 override CFLAGS +=-Iinclude

=== test/Makefile ===

# Copyright (C) 2018-2024 Ruilin Peng (Nick) <pymumu@gmail.com>.
#
# smartdns is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# smartdns is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

BIN=test.bin
CFLAGS += -I../src -I../src/include
CFLAGS += -DTEST
CFLAGS += -g -Wall -Wstrict-prototypes -fno-omit-frame-pointer -Wstrict-aliasing -funwind-tables -Wmissing-prototypes -Wshadow -Wextra -Wno-unused-parameter -Wno-implicit-fallthrough

CXXFLAGS += -g
CXXFLAGS += -DTEST
CXXFLAGS += -I./ -I../src -I../src/include

OBJS_LIB=$(patsubst %.c,%.o,$(wildcard ../src/lib/*.c))
OBJS_MAIN=$(patsubst %.c,%.o,$(wildcard ../src/*.c))
OBJS = $(OBJS_LIB) $(OBJS_MAIN)

TEST_SOURCES := $(wildcard *.cc) $(wildcard */*.cc) $(wildcard */*/*.cc)
TEST_OBJECTS := $(patsubst %.cc, %.o, $(TEST_SOURCES))
OBJS += $(TEST_OBJECTS)

LDFLAGS += -lssl -lcrypto -lpthread -ldl -lgtest -lstdc++ -lm

.PHONY: all clean test

all: $(BIN)

$(BIN) : $(OBJS)
	$(CC) $(OBJS) -o $@ $(LDFLAGS)

test: $(BIN)
	./$(BIN)

clean:
	$(RM) $(OBJS) $(BIN)

=== plugin/demo/Makefile ===

# Copyright (C) 2018-2024 Ruilin Peng (Nick) <pymumu@gmail.com>.
#
# smartdns is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# smartdns is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

BIN=smartdns-demo.so 
OBJS_MAIN=$(patsubst %.c,%.o,$(wildcard *.c))
OBJS=$(OBJS_MAIN)

# cflags
ifndef CFLAGS
 ifdef DEBUG
  CFLAGS = -g -DDEBUG
 else
  CFLAGS = -O2
 endif
 CFLAGS +=-fPIC -Wall -Wstrict-prototypes -fno-omit-frame-pointer -Wstrict-aliasing -funwind-tables -Wmissing-prototypes -Wshadow -Wextra -Wno-unused-parameter -Wno-implicit-fallthrough
endif

override CFLAGS +=-Iinclude -I../../src/include -I../../src
override CFLAGS += -DBASE_FILE_NAME='"$(notdir $<)"'
override CFLAGS += $(EXTRA_CFLAGS)

override LDFLAGS += -lpthread -shared

.PHONY: all clean

all: $(BIN)

$(BIN) : $(OBJS)
	$(CC) $(OBJS) -o $@ $(LDFLAGS)

clean:
	$(RM) $(OBJS) $(BIN)

=== package/tool/po2lmo/Makefile ===

INSTALL = install
PREFIX  = /usr/bin
CFLAGS  = -Wall -O2
po2lmo: src/po2lmo.o src/template_lmo.o
	$(CC) $(LDFLAGS) -o src/po2lmo src/po2lmo.o src/template_lmo.o

install:
	$(INSTALL) -m 755 src/po2lmo $(PREFIX)

clean:
	$(RM) src/po2lmo src/*.o

=== debian/rules ===
--- 
+++ 
@@ -16,3 +16,9 @@
 	cp -v alipay_donate.jpg doc/
 	cp -v wechat_donate.jpg doc/
 	:
+
+override_dh_auto_clean:
+	dh_auto_clean
+	# this fixes FTBFS twice in a row #1047008
+	-$(RM) alipay_donate.jpg wechat_donate.jpg
+	-$(RM) doc/alipay_donate.jpg doc/wechat_donate.jpg

=== debian/tests/control ===
Test-Command: /usr/sbin/smartdns -v
Depends: @
Restrictions: allow-stderr, superficial
